/*
  Programma che mostra l'uso dell'ereditariet:
  gerarchia d'eredit:
               [ Punto <--- Cerchio ]
*/

import javax.swing.JOptionPane;
import java.math.BigInteger;

//==================================classe Punto=========================================
class Punto extends Object
{
  protected int x, y;                //coordinate del punto
    
  //costruttore senza argomenti
  public Punto () {
    x = 0;
    y = 0;
  }
  
  //Costruttore
  public Punto (int a, int b) {
    x = a;
    y = b;
  }
  
  //ridefinizione del metodo toString() della classe Object
  public String toString() {
    return "["+x+","+y+"]";
  }
  
  //metodo di accesso che restituisce x
  public int getX () {
    return x;
  }
  
  //metodo di accesso che restituisce y
  public int getY () {
    return y;
  }
}


//===================================classe Cerchio=======================================
class Cerchio extends Punto
{
  protected double raggio;
    
  public Cerchio () {
    super ();
    raggio = 0.0;
  }
  
  public Cerchio (int a, int b, double raggio) {
    super (a, b);
    this.raggio = raggio;
  }
  
  //ridefinizione del metodo toString() della classe Punto
  public String toString () {
    return "Cerchio avente centro: ["+x+","+y+"] e raggio "+raggio;
  }
  
  //metodo di accesso alla variabile raggio
  public double getRaggio () {
    return raggio;
  }
  
  //altri metdodi
  public double getArea () {
    return Math.PI * raggio * raggio;
  }
  
  public double getCirconferenza () {
    return 2 * Math.PI * raggio;
  }
}


//============================classe pubblica per il test================================
public class Ex01 extends Object
{
  //metodo main
  public static void main (String[] args) {
    //creazione di una nuova istanza Punto
    Punto ilMioPunto = new Punto (3,5);  //il punto avr coordinate [3,5]
    
    //test del metodo toString() della classe Punto
    JOptionPane.showMessageDialog (null,
    "Il tuo punto ha coordinate: "+ilMioPunto.toString(),
    "Dimostrazione dell'uso di toString() overriding",
    JOptionPane.INFORMATION_MESSAGE);
    
    //creazione di una nuova istanza Cerchio
    Cerchio ilMioCerchio = new Cerchio (4,2,3.55);
    
    //test del metodo toString() della classe Cerchio
    JOptionPane.showMessageDialog (null,
    ilMioCerchio.toString(), "Dimostrazione dell'uso di toString() overriding",
    JOptionPane.INFORMATION_MESSAGE);
    
    //calcolo dell'area e della circonferenza
    JOptionPane.showMessageDialog (null,
    "Area del cerchio = "+ilMioCerchio.getArea()+"\nCirconferenza = "+
    ilMioCerchio.getCirconferenza(),
    "Output", JOptionPane.INFORMATION_MESSAGE);
    
    System.exit (0);
    
  }
}
