//Secondo set di esercizi in Java:  Progetto 2

/*
Un intervallo  dato dai suoi estremi.
Si considerino due insiemi di intervalli A ={I1, I2, I3, I5, ... , IN} 
e B={J1, J2, J3, ..., JM} (M e N al massimo valgano 10).
Un insieme di intervalli si dice minimale se i suoi intervalli 
sono tutti a due a due disgiunti. 
Dato un insieme di intervalli si vuole sapere se  
minimale e calcolarne uno minimale equivalente.
Dato un insieme di intervalli si vuole sapere la misura 
complessiva di tutti i suoi intervalli.
Dati due insiemi di intervalli si vuole calcolare la 
loro intersezione che  l'insieme di intervalli 
ottenuto prendendo le intersezioni comuni tra 
un intervallo di A e un intervallo di B.
Scrivere classi adeguati ed utilizzarle in un 
programma di "prova" che crei due insiemi di 
intervalli casualmente, dica se sono minimali e ne dia la misura.
Successivamente i due insiemi vengono intersecati 
e si fornisce un insieme di intervalli minimale 
equivalente a tale intersezione.
Esempio: 
A={[0,3], [2,16],[19,21]}; B={[10,17], [18,20]}; 
A non  minimale, un insieme di intervalli 
minimale equivalente ad A  C={[0,16],[19,21]} che ha misura 18;
B  minimale con misura 9.
La intersezione dei due insiemi di intervalli 
secondo la definizone data sopra : D={[10,16], [18,20]}
che ha misura 8.
*/

import javax.swing.JOptionPane;
import java.math.*;

//=================================classe Intervallo=====================================
class Intervallo extends Object 
{
  private int inf, sup;		//estremi inferiore e superiore di ogni istanza
		
  //Costruttore
  public Intervallo (int a, int b) {
    inf = a;
    sup = b;
  }
	
  //costruttore senza argomenti
  public Intervallo () {	//intervallo standard
    inf = 1;
    sup = 2;
  }
  
  //metodo predicativo che verifica se l'intervallo  vuoto
  public boolean isEmpty () {
    if (inf ==  sup) return true;
    else { return false; }
  }
  
  //metodi di accesso
  public int getInf()                   { return inf; }
  public int getSup()                   { return sup; }
  public int getMisura()                { return sup - inf; }
  
  //ridefinizione del metodo toString() della classe Object
  public String toString() {
    return "["+inf+","+sup+"]"; 
  }
  
  //metodo per il calcolo dell'intersezione fra due intervalli
  public Intervallo interseca (Intervallo unIntervallo) {
    int i,s;
    if (inf > unIntervallo.getSup() || sup < unIntervallo.getInf()) {
      //l'intersezione  vuota
      return new Intervallo (0,0); }
    else /* se l'intersezione non  vuota */ {
      i = Math.max (inf, unIntervallo.getInf());
      s = Math.min (sup, unIntervallo.getSup());
      return new Intervallo (i, s); 
    }
  }
}

//===================================classe InsiemeIntervalli=============================
class InsiemeIntervalli extends Object
{
  private Intervallo[] listaIntervalli;
    
  public InsiemeIntervalli (Intervallo[] degliIntervalli) {
    listaIntervalli = new Intervallo [degliIntervalli.length];
    for (int i = 0; i < degliIntervalli.length; i++) {
      listaIntervalli[i] = degliIntervalli[i];
    }
  }
  
  //metodo che restituisce la lunghezza totale dell'inisieme degli intervalli
  public int getLunghezzaTotale () {
    int lunghezzaTotale = 0;
    for (int i = 0; i < listaIntervalli.length; i++) {
      lunghezzaTotale += listaIntervalli[i].getMisura ();
    }
    return lunghezzaTotale;
  }
  
  //metodi di "servizio"
  private void ordinaIntervalli () {
    //algoritmo di ordinamento : "SelectionSort"
    int min;
    
    for (int index = 0; index < listaIntervalli.length - 1; index++) {
      min = index;
      
      for (int i = index + 1; i < listaIntervalli.length; i++) {
        if (listaIntervalli[i].getInf() < listaIntervalli[min].getInf()) {
          
          min = i;
        }
      }
      
      swap (listaIntervalli, min, index);
    }
  }
  
  private void swap (Intervallo[] a, int primo, int secondo)  {
    Intervallo tmp = a[primo];
    a[primo] = a[secondo];
    a[secondo] = tmp;
  }
  
  //metodo che verifica se l'insieme di intervalli  minimale
  public boolean isMinimal() {
    ordinaIntervalli();
    for (int i = 0; i < listaIntervalli.length; i++) {
      if (listaIntervalli[i].getSup() > listaIntervalli[i+1].getInf()) {
        return false;
      }
    }
    return true;
  }
  
  public String toString () {
    String output = "";
    for (int i = 0; i < listaIntervalli.length; i++) {
      output += listaIntervalli[i].toString() + "\n";
    }
    return output;
  }
}
