/*
	Secondo set di esercizi in Java.
	PROGETTO 1: simulazione/gioco di una borsa valori
*/

import java.math.*;

//=============================classe Investitore===============================
class Investitore
{
	private String nome, cognome;
	private int budgetIniziale, budget;
		
	//metodi costruttori
	public Investitore (String mioNome, String cognome, int sommaIniziale) {
		nome = mioNome;
		this.cognome = cognome;
		budgetIniziale = sommaIniziale;
		budget = sommaIniziale;
	}
	
	public Investitore () {
		nome = "Anonimo";
		cognome = "Anonimo";
		budgetIniziale = 1000;
		budget = 1000;
	}
	
	//metodi di accesso
	public int getBudget ()
	{ return budget; }
	
	public String getNome () {
		return nome; }
	
	//metodi per le operazioni di borsa dell'investotore
	public void acquistaTitolo (Titolo unTitolo) {
		if (unTitolo.getValore() < budget)
			budget -= unTitolo.getValore();
		else { /* niente acquisto! */ }
	}
	public void vendiTitolo (Titolo unTitolo) {
		budget += unTitolo.getValore();
	}
	
	
	public int getBudgetIniziale() {
		return budgetIniziale; }
	
		
	public String assegnazione() {
		if (budgetIniziale <= budget) {
			return "un genio della finanza"; }
		else {
			return "il fesso della settimana";	}	
	}
}

//================================classe Titolo========================================================
class Titolo
{
	private String nomeTitolo;
	private int valoreTitolo;
		
	public Titolo (String nomeTitolo, int valoreTitolo) {
		this.nomeTitolo = nomeTitolo;
		this.valoreTitolo = valoreTitolo;
	}
	
	public int getValore () {
		return valoreTitolo; }
		
	public String getNomeTitolo () {
		return nomeTitolo; }
		
	public void setValore () {
		valoreTitolo = (int)(500 * Math.random () + 10);
	}
}

//================================classe pubblica LaBorsa================================================

/*
	Questa classe viene utilizzata per il test
*/

public class LaBorsa
{
	static String nome1 = "Fabio";
	static String cognome1 = "Rinnone";
	static int budget1 = 2000;
	
	static String nome2 = "Sabrina";
	static String cognome2 = "Rinnone";
	static int budget2 = 2000;
	
	static String nomeTitolo1 = "Pere cotte";
	static int valoreTitolo1 = 500;
	
	static String nomeTitolo2 = "Acido cianidrico";
	static int valoreTitolo2 = 800;
	
	public static void main (String[] args)
	{
		
		//creazione dei vari oggetti
		Investitore fabio   = new Investitore (nome1, cognome1, budget1);
		Investitore sabrina = new Investitore (nome2, cognome2, budget2);
		
		Titolo primoTitolo   = new Titolo (nomeTitolo1, valoreTitolo1);
		Titolo secondoTitolo = new Titolo (nomeTitolo2, valoreTitolo2);
		
		
		for (int contatore = 1; contatore < 6; contatore ++)
		{
			fabio.acquistaTitolo(primoTitolo);
			sabrina.acquistaTitolo(secondoTitolo);
			primoTitolo.setValore();
			secondoTitolo.setValore();
			fabio.vendiTitolo(primoTitolo);
			sabrina.vendiTitolo(secondoTitolo);
			
			System.out.println(
			"Pere cotte \t\t= "+primoTitolo.getValore());
			System.out.println(
			"Acido cianidrico \t= "+secondoTitolo.getValore());
			
			fabio.acquistaTitolo(secondoTitolo);
			sabrina.acquistaTitolo(primoTitolo);
			primoTitolo.setValore();
			secondoTitolo.setValore();
			fabio.vendiTitolo(primoTitolo);
			sabrina.vendiTitolo(secondoTitolo);
			
			System.out.println(
			"Pere cotte \t\t= "+primoTitolo.getValore());
			System.out.println(
			"Acido cianidrico \t= "+secondoTitolo.getValore());
			
			System.out.print (
			"Al giorno "+contatore+" di contrattazioni "+fabio.getNome()+" ha un budget pari a: ");
			System.out.println (
			fabio.getBudget()+"$");
			System.out.println (
			sabrina.getNome()+ " possiede, invece, "+sabrina.getBudget()+"$");
			System.out.println();
			
			System.out.println ("Budget iniziale di "+fabio.getNome()+" = "+fabio.getBudgetIniziale()+"$");
			
		}
		
		System.out.print (
		"Alla fine della settimana "+fabio.getNome()+" = "+fabio.assegnazione());
		System.out.println (" e "+sabrina.getNome()+" = "+sabrina.assegnazione());
		
		System.exit (0);
	}
}
