/**
  Classe di geometria analitica piana:
  controlla le coordinate di un punto;
  calcola la distanza fra due punti;
  calcola le coordinate del punto medio;
  verifica se due punti sono simmetrici fra loro;
*/

/**
 * @author Fabio Rinnone
 * @version 0.1 alpha del 20/02/2003
 */
 
public class PointOfPlane {
  private double x, y;
  
  /** 
   * Metodo costruttore per la classe PointOfPlane;
   * @param double a, double b;
   */  
  public PointOfPlane (double a, double b) {
    x = a;
    y = b;
  }
  
  //costruttore senza argomenti
  public PointOfPlane () {
    x = 1;
    y = 1;
  }
  
  //metodi di accesso
  public double getX ()            { return x; }
  public double getY ()            { return y; }
  
  //metodo per il calcolo della distanza
  public double getDistance (PointOfPlane a) {
    return Math.sqrt(Math.pow(a.getX()-x,2)+(Math.pow(a.getY()-y,2)));
  }
  
  //metodo che determina il punto medio
  public PointOfPlane getMediusPoint (PointOfPlane a) {
    double abscissa, ordinate;
    abscissa = x + a.getX() / 2;
    ordinate = y + a.getY() / 2;
    return new PointOfPlane(abscissa, ordinate);
  }
  
  //metodo che verifica se due punti sono simmetrici
  public boolean isSymmetricOrigin (PointOfPlane a) {
    if (x == -1*a.getX() && y == -1*a.getY())
      return true;
    else
      return false;
  }
  
  public boolean isSymmetricAbscissa (PointOfPlane a) {
    if (x == a.getX() && y == -1*a.getY())
      return true;
    else
      return false;
  }
  
  public boolean isSymmetricOrdinate (PointOfPlane a) {
    if (x == -1*a.getX() && y == a.getY())
      return true;
    else
      return false;
  }  
}
