/*
  TEMA 11
  Si consideri una collezione di 6 forme geometriche che 
  possono essere o triangoli rettangoli (assegnati mediante i cateti) 
  e di rettangoli (assegnati mediante i lati).
  
  Si scriva codice JAVA per:
  
  a) generare a caso (sia nel tipo che nelle dimensioni) la collezione di forme;
  b) stampare a schermo informazioni complete su ciascun
  elemento della collezione generate (ridefinendo il metodo toString());
  c) calcolare l'area complessiva di tutte e 6 le forme.
  d) trovare la forma di area minima.
  
  CONSIGLIO: evitare l'uso di JOptionPane;
*/

import java.math.*;

//===============================classe Figura============================================
abstract class Figura extends Object
{
  protected int dim1, dim2;
    
  public Figura (int a, int b) {
    dim1 = a;
    dim2 = b;
  }
  
  public int getDim1 ()         { return dim1; }
  public int getDim2 ()         { return dim2; }
  
  abstract public double getArea ();
}

//===============================classe Rettangolo========================================
class Rettangolo extends Figura
{
  public Rettangolo (int a, int b) {
    super (a, b);
  }
  
  public double getArea ()      { return dim1 * dim2; }
  
  //overriding del metodo toString() della classe Object
  public String toString () {
    return "Rettangolo: base = "+dim1+"; altezza = "+dim2;
  }
}

//===============================classe Triangolo=========================================
class Triangolo extends Rettangolo
{
  protected double ipo;
  
  //costruttore con due parametri
  public Triangolo (int a, int b) {
    super (a, b);
    ipo = setIpo();
  }
  
  public double setIpo () {
    return Math.sqrt (dim1*dim1 + dim2*dim2);
  }
  
  public double getIpo ()          { return ipo; }
  
  public double getArea ()         { return dim1 * dim2 / 2; }
  
  public String toString () {
    return "Triangolo rettangolo: cateto1 = "+dim1+"; cateto2 = "+dim2+
    "; ipotenusa = "+ipo;
  }
}

//===============================classe Tema11==============================================
public class Tema11
{
  public static void main (String[]args)
  {
    Figura []leMieFigure = new Figura [5];
    int i;
    for (i = 0; i < leMieFigure.length; i++) {
      if (Math.random() < .5) 
        leMieFigure[i] = new Rettangolo ((int)(11*Math.random()+1),
                                         (int)(11*Math.random()+1));
      else
        leMieFigure[i] = new Triangolo  ((int)(11*Math.random()+1),
                                         (int)(11*Math.random()+1));
    }
    
    for (i = 0; i < leMieFigure.length; i++) {
      System.out.println ("Figura "+i+") "+leMieFigure[i].toString());
    }
    
    int areaComplessiva = 0;
    for (i = 0; i < leMieFigure.length; i++) {
      areaComplessiva += leMieFigure[i].getArea();
    }
    System.out.println ("L'area complessiva : "+areaComplessiva);
    
    int min = 0;
    for (i = 1; i < leMieFigure.length; i++) {
      if (leMieFigure[min].getArea() > leMieFigure[i].getArea())
        min = i;
    }
    System.out.println ("La figura di area minore : "+min);
    
    System.exit(0);
  }
}
