/*
  TEMA 5
  Un laboratorio di pasticceria produce torte di vario 
  peso e composizione.Le torte sono di due tipi: frutta e non frutta. 
  Per ogni torta si conosce il peso e il prezzo complessivo.
  Sia dato un bancone di 25 torte (le cui caratteristiche 
  possono essere assegnate a caso).
  
  Scrivere un programma JAVA che consenta di conoscere:
  
  a)   il peso complessivo delle torte alla frutta;
  b)   il peso complessivo delle torte non frutta;
  c)   quale torta non frutta ha il prezzo pi basso al kilogrammo;
  d)   quale torta frutta ha il prezzo pi alto al kilogrammo.
*/

import java.math.*;

//==================================classe Torta============================================
class Torta extends Object
{
  protected int pesoComplessivo, prezzoComplessivo;
    
  //Costruttore
  public Torta (int pesoComplessivo, int prezzoComplessivo) {
    this.pesoComplessivo = pesoComplessivo;
    this.prezzoComplessivo = prezzoComplessivo;
  }
  
  //metodi di accesso
  public int getPesoComplessivo ()      { return pesoComplessivo; }
  public int getPrezzoComplessivo ()    { return prezzoComplessivo; }
  
  //restituisce il prezzo al chilogrammo
  public double getPrezzoKilo ()        { return (double)prezzoComplessivo /
                                          pesoComplessivo; }
}

//=================================classe ConFrutta========================================
class ConFrutta extends Torta
{
  protected int pesoFrutta, prezzoFrutta;
    
  public ConFrutta (int pesoC, int PrezzoC, int pesoF, int prezzoF) {
    super (pesoC, prezzoF);
    pesoComplessivo += pesoF;
    prezzoComplessivo += prezzoF;
  }
}

//=================================classe Laboratorio======================================
public class Laboratorio
{
  public static void main (String[] args)
  {
    Torta []bancone = new Torta [25];
    //inizializzazione random di bancone
    int i;
    for (i = 0; i < bancone.length; i++)
      if (Math.random() < .5) bancone [i] = new Torta ((int)(6*Math.random()+1),
                                                       (int)(25*Math.random()+5));
      else {bancone [i] = new ConFrutta ((int)(6*Math.random()+1),
                                        (int)(25*Math.random()+5),
                                        (int)(2*Math.random()+1),
                                        (int)(Math.random()+1));}
    
    //calcolo il peso complessivo delle torte con frutta
    int pesoTotale = 0;
    for (i = 0; i < bancone.length; i++)
      if (bancone[i] instanceof ConFrutta)
        pesoTotale += bancone[i].getPesoComplessivo();
    System.out.println ("Peso totale torte senza frutta = "+pesoTotale+"Kg");
      
    //calcolo il peso complessivo delle torte senza frutta
    pesoTotale = 0;
      for (i = 0; i < bancone.length; i++)
      if (bancone[i] instanceof Torta)
        pesoTotale += bancone[i].getPesoComplessivo();
    System.out.println ("Peso totale torte con frutta = "+pesoTotale+"Kg");
    
    System.exit(0);
  }
}