/*
  TEMA 6
  Si consideri una collezione di 25 blocchi rettangolari di dimensioni (double):
  ALTEZZA ( un valore random tra 1 e 10 metri)
  LARGHEZZA (un valore random tra 1 e 10 metri)
  PROFONDITA' (un valore random tra 1 e 10 metri)
  
  E dei seguenti materiali:
  
  PIETRA (kg 20.000 al metro cubo)
  PIOMBO (kg 50.000 al metro cubo)
  PLATICA (kg 300 al metro cubo)
  
  Si scriva un programma JAVA che dica:
  
  a)   quale  tra i 25 il blocco di volume maggiore;
  b)   quale  tra i 25 il blocco di volume minore;
  c)   quale  tra i 25 il blocco pi pesante;
  d)   quale  tra i 25 il blocco pi leggero;
  e)   il peso complessivo di tutti i blocchi.
*/

import java.math.*;

//====================================classe Blocco========================================
abstract class Blocco extends Object
{
  protected int altezza, larghezza, profondita;
    
  //Costruttore
  public Blocco (int a, int b, int c) {
    altezza = a;
    larghezza = b;
    profondita = c;
  }
  
  //metodi di accesso
  public int getAltezza ()      { return altezza; }
  public int getLarghezza ()    { return larghezza; }
  public int getProfondita ()   { return profondita; }
  
  //metodo per il calcolo del volume
  public int getVolume ()       { return altezza * larghezza * profondita; }
  //metodo astratto per il calcolo del peso di ogni blocco
  abstract public long getPeso ();
}

//====================================classe Pietra========================================
class Pietra extends Blocco
{
  //nessuna variabile di istanza
  
  public Pietra (int a, int b, int c) {
    super (a, b, c);            //richiamo il costruttore della superclasse
  }
  
  public long getPeso () {
    return 2000 * this.getVolume();
  }
}

//====================================classe Piombo========================================
class Piombo extends Blocco
{
  //nessuna variabile di istanza
  
  public Piombo (int a, int b, int c) {
    super (a, b, c);
  }
  
  public long getPeso () {
    return 5000 * this.getVolume();
  }
}

//====================================classe Plastica======================================
class Plastica extends Blocco
{
  //nessuna variabile di istanza
  
  public Plastica (int a, int b, int c) {
    super (a, b, c);
  }
  
  public long getPeso () {
    return 30 * this.getVolume(); 
  }
}

//====================================classe Tema6==========================================
public class Tema6
{
  public static void main (String []args) {
    Blocco []iBlocchi = new Blocco [25];
    //inizializzazione casuale dell'array di blocchi
    int i, random;
    for (i = 0; i < iBlocchi.length; i++) {
      random = (int)(4 * Math.random () + 1);
      if (random == 1)
        iBlocchi[i] = new Pietra ((int)(11 * Math.random () + 1),
                                  (int)(11 * Math.random () + 1),
                                  (int)(11 * Math.random () + 1));
      else if (random == 2)
        iBlocchi[i] = new Piombo ((int)(11 * Math.random () + 1),
                                  (int)(11 * Math.random () + 1),
                                  (int)(11 * Math.random () + 1));
      else iBlocchi[i] = new Plastica ((int)(11 * Math.random () + 1),
                                       (int)(11 * Math.random () + 1),
                                       (int)(11 * Math.random () + 1));
    }
  
    //ricerco il blocco di peso maggiore fra i 25 creati
    int max = 0;
    for (i = 1; i < iBlocchi.length; i++) {
      if (iBlocchi[max].getPeso() < iBlocchi[i].getPeso())
        max = i;
    }
    System.out.println ("Blocco pi pesante: "+max+"; peso = "+iBlocchi[max].getPeso());
    
    //ricerco il blocco di peso minore fra i 25 creati
    int min = 0;
    for (i = 1; i < iBlocchi.length; i++) {
      if (iBlocchi[max].getPeso() > iBlocchi[i].getPeso())
        min = i;
    }
    System.out.println ("Blocco pi leggero: "+min+"; peso = "+iBlocchi[min].getPeso());
    
    //ricerco il blocco di volume maggiore fra i 25 creati
    max = 0;
    for (i = 1; i < iBlocchi.length; i++) {
      if (iBlocchi[max].getVolume() < iBlocchi[i].getVolume())
        max = i;
    }
    System.out.println (
    "Blocco pi vouminoso: "+max+"; volume = "+iBlocchi[max].getVolume());
    
    //ricerco il blocco di volume minore fra i 25 creati
    min = 0;
    for (i = 1; i < iBlocchi.length; i++) {
      if (iBlocchi[max].getVolume() > iBlocchi[i].getVolume())
        min = i;
    }
    System.out.println (
    "Blocco meno voluminoso: "+min+"; volume = "+iBlocchi[min].getVolume());
    
    //calcolo il peso complessivo
    int pesoComplessivo = 0;
    for (i = 0; i < iBlocchi.length; i++) {
      pesoComplessivo += iBlocchi[i].getPeso();
    }
    System.out.println("Il peso complessivo : "+pesoComplessivo);
    
    System.exit(0);
    
  }
}
