/*
  TEMA 7
  Si considerino cinque studenti.
  Un primo tipo di studenti segue i corsi A e B.
  Un secondo tipo di studenti segue i corsi A, B e C.
  Per ciascuno studente si vuole mantenere 
  informazione relativamente al suo nome (tratto a caso dall'insieme 
  {"Silvia", "Guido","Mattia", "Angelo", "Marina"}).
  Si vuole anche mantenere informazione riguardo ai 
  voti conseguiti nei corsi frequentati.

  Scrivere codice JAVA che consenta di:
  a) inizializzare a caso l'insieme degli studenti;
  b) stampare a schermo informazioni complete su tutti 
  gli studenti (ridefinendo il metodo toString());
  c) stampare il nome dello studente com media massima 
  e dello studente con media minima;
  d) dire se ci sono due studenti con lo stesso nome;

  CONSIGLIO: evitare l'uso di JOptionPane;
*/

import java.math.*;

//=================================classe Studente========================================
abstract class Studente extends Object
{
  protected String nome;
    
  //Costruttore
  public Studente (String nome) {
    this.nome = nome;
  }
  
  public String getNome () { return nome; }
  
  //abstract public String toString ();    
  abstract public int getVotoCorsoA ();
  abstract public int getVotoCorsoB ();
  abstract public double getMedia ();
}

//=================================classe PrimoTipo=======================================
class PrimoTipo extends Studente
{
  protected int votoCorsoA, votoCorsoB;
    
  //Costruttore
  public PrimoTipo (String nome, int a, int b) {
    super (nome);
    votoCorsoA = a;
    votoCorsoB = b;
  }
  
  //metodi di accesso ai voti
  public int getVotoCorsoA () { return votoCorsoA; }
  public int getVotoCorsoB () { return votoCorsoB; }
  public double getMedia () {
    return (double)(votoCorsoA + votoCorsoB) / 2;
  }
  
  //overriding del metodo toString()
  public String toString () {
    return "Nome: "+nome+",\nvoto corso A = "+votoCorsoA+",\nvoto corso B = "+votoCorsoB;
  }
}

//=================================classe SecondoTipo=====================================
class SecondoTipo extends PrimoTipo
{
  protected int votoCorsoC;
    
  //Costruttore
  public SecondoTipo (String nome, int a, int b, int c) {
    super (nome, a, b);
    votoCorsoC = c;
  }
  
  //metodo per l'accesso al voto del corso C
  public int getVotoCorsoC () { return votoCorsoC; }
  public double getMedia () {
    return (double)(votoCorsoA + votoCorsoB + votoCorsoC) / 3;
  }
  
  public String toString () {   //nuova ridefinizione del metodo toString()
    return
    "Nome: "+nome+",\nvoto corso A = "+votoCorsoA+",\nvoto corso B = "
    +votoCorsoB+",\nvoto corso C = "+votoCorsoC;
  }
}

//=================================classe Insieme=========================================
public class Insieme extends Object
{
  public static void main (String[] args) {
    //inizializzo casualmente i dati degli studenti
    Studente []iMieiStudenti = new Studente [5];
    String []nomi = {"Silvia", "Guido", "Mattia", "Angelo", "Marina"};
    int random; 
    int i;
    for (i = 0; i < iMieiStudenti.length; i++) {
      random = (int)(5 * Math.random ());
      if (Math.random() < .5) 
        iMieiStudenti[i] = new PrimoTipo (nomi[random],
                                         (int)(11 * Math.random () + 18),
                                         (int)(11 * Math.random () + 18));
      else iMieiStudenti[i] = new SecondoTipo (nomi[random],
                                              (int)(11 * Math.random () + 18),
                                              (int)(11 * Math.random () + 18),
                                              (int)(11 * Math.random () + 18));
    }
    
    for (i = 0; i < iMieiStudenti.length; i++) {
      System.out.println (iMieiStudenti[i].toString());  //grazie al polimorfismo
    }
    
    //cerco lo studente con media pi alta
    int max = 0;
    for (i = 0; i < iMieiStudenti.length; i++) {
      if (iMieiStudenti[max].getMedia() < iMieiStudenti[i].getMedia())
        max = i;
    }
    System.out.println ("Lo studente con media maggiore  "+iMieiStudenti[max].getNome());
    
    //controllo se vi sono sue studenti o pi con lo stesso nome
    boolean stessoNome = false;
    for (i = 0; i < iMieiStudenti.length; i++) {
      for (int j = 0; j < iMieiStudenti.length && j != i; j++){
        if (iMieiStudenti[j].getNome().equals(iMieiStudenti[i].getNome())){
          stessoNome = true;
        }
      }
    }
    System.out.println ("Stesso nome? "+stessoNome);
    
    System.exit (0);
  }
}
