/*
  TEMA 9
  Si considerino gli oggetti geometrici "circonferenze" e "quadrati".
  Le prime sono assegnate conoscendo le coordinate 
  (x,y) del centro e il valore non negativo del raggio.
  Le seconde sono assegnate conoscendo le coordinate 
  del vertice in basso a sinistra e la lunghezza non negativa del lato.

  Scrivere codice JAVA per:
  a) generare e gestire una collezione di 
  sette oggetti geometrici,scelti a caso tra 
  circonferenze e quadrati e di 
  dimensioni e posizioni casuali;
  b) stampare a schermo informazioni sugli oggetti 
  generati ridefinendo il metodo toString();
  c) calcolare l'area complessiva di tutti gli oggetti;
  d) indicare quale delle sette forme geometriche 
  ha area massima.

  CONSIGLIO: evitare l'uso di JOptionPane;
*/

import java.math.BigInteger;

//=================================classe Figura==========================================
abstract class Figura extends Object
{
  protected int x, y;   //coordinate del punto
    
  //Costruttore
  public Figura (int x, int y) {
    this.x = x;
    this.y = y;
  }
  
  //metodo di accesso a x
  public int getX () { return x; }
  //metodo di accesso a y
  public int getY () { return y; }
  
  abstract public String toString ();  //metodo astratto per la visualizzazione delle info
  abstract public double getArea ();   //metodo astratto per il calcolo dell'area
}

//=================================classe Circonferenza===================================
class Circonferenza extends Figura
{
  protected double raggio;      //variabile d'istanza specifica della circonferenza
    
  //Costruttore
  public Circonferenza (int x, int y, double raggio) {
    super (x, y);
    this.raggio = raggio;
  }
  
  //metodo di accesso al raggio
  public double getRaggio () { return raggio; }
  
  /*    overriding del metodo toString() della classe 
        Object dichiarato astratto in Figura            */
  public String toString () {
    return "Il cerchio ha centro in ["+x+","+y+"] ed ha raggio "+raggio;
  }
  
  //metodo per il calcolo del'area del cerchio
  public double getArea () {
    return Math.PI * raggio * raggio;
  }
}

//=================================classe Quadrato========================================
class Quadrato extends Figura
{
  protected double lato;
    
  public Quadrato (int x, int y, double lato) {
    super (x, y);
    this.lato = lato;
  }
  
  //metodo di accesso al lato
  public double getLato () { return lato; }
  
  //anche qui ridefinizione del metodo toString()
  public String toString() {
    return "Vertice sinistro in basso:["+x+","+y+"] e lato = "+lato;
  }
  
  //metodo per il calcolo dell'area
  public double getArea () {
    return lato * lato;
  }
}

//=================================classe Tema9============================================
public class Tema9
{
  public static void main (String[] args)
  {
    //inizializzazione random di tutte le variabili
    Figura []leMieFigure = new Figura [7];
    int i;
    for (i = 0; i < leMieFigure.length; i++) {
      if (Math.random() < .5)
        leMieFigure[i] = new Quadrato ((int)(10 * Math.random() + 1),
                                       (int)(10 * Math.random() + 1),
                                       (int)(20 * Math.random() + 5));
      else
        leMieFigure[i] = new Circonferenza ((int)(10 * Math.random() + 1),
                                            (int)(10 * Math.random() + 1),
                                            (int)(20 * Math.random() + 5));
    }
    
    
    //calcolo dell'area complessiva di tutti gli oggetti
    double areaComplessiva = 0;
    for (i = 0; i < leMieFigure.length; i++) {
      areaComplessiva += leMieFigure[i].getArea();      //sfruttando il polimorfismo
    }
    System.out.println ("L'area complessiva  "+areaComplessiva);
    
    //ricerco la figura con area massima
    int max = 0;
    for (i = 1; i < leMieFigure.length; i++) {
      if (leMieFigure[max].getArea() < leMieFigure[i].getArea())
        max = i;
    }
    System.out.print ("La figura con area massima  la numero "+max+" che  ");
    System.out.println (
    leMieFigure[max].getClass()+" ed ha area = "+leMieFigure[max].getArea());
    
    System.exit(0);
  }
}
